/*
 * @(#)ChatArea.java
 *
 * Copyright (c) 2002, Jang-Ho Hwang
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 	1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 *
 * 	2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 *
 * 	3. Neither the name of the Jang-Ho Hwang nor the names of its contributors
 * may be used to endorse or promote products derived from this software
 * without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *    $Id: ChatArea.java,v 1.1.1.1 2002/03/08 21:20:46 xrath Exp $
 */
package rath.jmsn.ui;

import java.awt.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import javax.swing.*;

import java.io.IOException;
import java.util.List;

/**
 * ä ȭâ Ʈ
 *
 * @author Jangho Hwang, rath@linuxkorea.co.kr
 * @version $Id: ChatArea.java,v 1.1.1.1 2002/03/08 21:20:46 xrath Exp $
 */
public abstract class ChatArea extends JTextArea
{
	public ChatArea()
	{
		setBorder( BorderFactory.createEmptyBorder(5,5,5,5) );
		new DropTarget( this, new DropListener() );
	}

	/**
	 * 巡    input java.io.File ü List ѿش.
	 *
	 * @param files DND   ϰü Ʈ
	 */
	public abstract void acceptFiles( List files );

	/**
	 * DND  BuddyTreeκ ģ ʴ ˷ش.
	 *
	 * @param loginName ʴϰϴ ģ༮ ̸
	 */
	public abstract void inviteFriend( String loginName );

	private class DropListener implements DropTargetListener
	{
		public void dragEnter( DropTargetDragEvent e ) {}
		public void dragExit( DropTargetEvent e ) {}
		public void dragOver( DropTargetDragEvent e ) {}
		public void dropActionChanged( DropTargetDragEvent e ) {}
		public void drop( DropTargetDropEvent event )
		{
			try
			{
				Transferable t = event.getTransferable();
				if( t.isDataFlavorSupported(DataFlavor.javaFileListFlavor) )
				{
					event.acceptDrop( DnDConstants.ACTION_MOVE );
					List filelist = (List)t.getTransferData( DataFlavor.javaFileListFlavor );
					event.getDropTargetContext().dropComplete( true );

					acceptFiles( filelist );
				}
				else
				if( t.isDataFlavorSupported(DataFlavor.stringFlavor) )
				{
				    event.acceptDrop( DnDConstants.ACTION_MOVE );
					String loginName = (String)t.getTransferData( DataFlavor.stringFlavor );
					event.getDropTargetContext().dropComplete( true );

					inviteFriend( loginName );
				}
				else
					event.rejectDrop();
			}
			catch( IOException e )
			{
				event.rejectDrop();
			}
			catch( UnsupportedFlavorException e )
			{
				event.rejectDrop();
			}
		}
	}
};
